//+------------------------------------------------------------------+
//|                                            Cable_Breakout_EA.mq4 |
//|                                                      Rob Cousins |
//|                                                                  |
//+------------------------------------------------------------------+

// Using the 1400-1600 GBP-USD breakout strategy put forward on forex-tsd
// by DZNMRD.  The system is to track the GBPUSD or pretty much any pair
// in its opening period or most active two hours, which for the cable is 
// defined here as 1400-1600 GMT.  I'll look at starting times a bit more when
// I know more about what I'm doing.  
// Using stop orders at the two hour high and low with small profit targets
// hoping to hit and run for a quick 10-20 pip profit.

#property copyright "rob_cousins(at)lycos.com"
#property link      ""
#include <stderror.mqh>
#include <stdlib.mqh>

extern double Lots=0.1;
extern int Profit_Points=15;
extern int gmt_offset=0;
extern int Magic=1234;
bool  Open_Trades,Pending_Trades;
double Upper_Limit,Lower_Limit;

int init()
  {
   return(0);
  }
  
int deinit()
  {
   return(0);
  }

void CheckTrade(int Magic) //checks for open or pending trades
{
   Open_Trades=false;Pending_Trades=false; // both false until they're not...
   for(int i=0;i<OrdersTotal();i++)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES); 
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic &&(OrderType()==OP_BUY||OrderType()==OP_SELL)) 
      {  Open_Trades=true;
         Close_Pending(Magic); // if there's an open trade then close the pending orders 
      }
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic &&(OrderType()==OP_BUYSTOP||OrderType()==OP_SELLSTOP)) Pending_Trades=true;
  }
}

void Close_Pending(int Magic) //closes all pending trades
{
   for(int i=0;i<OrdersTotal();i++)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES); 
      if((OrderType()==OP_BUYSTOP || OrderType()==OP_SELLSTOP) && OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) OrderDelete(OrderTicket(),Green);
   }
   Pending_Trades=false;
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{

int i=1;
Comment(
   "Hour =",Hour()," and Minute=",Minute()," and GMT Offset=",gmt_offset,"\n",
   "Upper Limit=",Upper_Limit,"\n",
   "Lower Limit=",Lower_Limit,"\n"
   );

if(Hour()<=14+gmt_offset && iVolume(NULL,240,0)<10) Close_Pending(Magic);  // expires all the open orders at midnight
CheckTrade(Magic);
  
if(Hour()==16+gmt_offset && Pending_Trades==false && Open_Trades==false) // at 1600 and no trades already open or pending
{
   Upper_Limit=NormalizeDouble(High[iHighest(NULL,60,MODE_HIGH,2,1)],Digits);
   Lower_Limit=NormalizeDouble(Low[iLowest(NULL,60,MODE_LOW,2,1)],Digits);
   double Halfway=(Upper_Limit+Lower_Limit)/2;
   OrderSend(Symbol(),OP_BUYSTOP,Lots,Upper_Limit,3,Halfway,Upper_Limit+Point*Profit_Points,NULL,Magic,0,Blue);
   OrderSend(Symbol(),OP_SELLSTOP,Lots,Lower_Limit,3,Halfway,Lower_Limit-Point*Profit_Points,NULL,Magic,0,Red);
}
return(0);
}

